let video;
let poseNet;

//Variablen um Punkte im Bild zu erfassen von Person 1 und Person 2
let schulterLX1;
let schulterLY1;
let huefteLX1;
let huefteLY1;
let schulterLX2;
let schulterLY2;
let huefteLX2;
let huefteLY2;

let abstandHS1; //Abstand Huefte-Schulter Person 1
let abstandHS2; //Abstand Huefte-Schulter Person 2
let abstandK1; //Abstand Kamera Person 1
let abstandK2; //Abstand Kamera Person 2
let abstandFinal; //Abstand zwischen den beiden Personen

function setup() {
  createCanvas(640, 480);
  video=createCapture (VIDEO);
  video.hide();
  poseNet = ml5.poseNet(video, modelReady);
  poseNet.on('pose',gotPoses);
  
  //p5 soll Winkel in Grad interpretieren
  angleMode(DEGREES);
}

function gotPoses (poses){
  console.log (poses);

  if(poses.length >1 ){
  
  //Variablen x,y der Posen in die deklarierten Variablen schreiben
  huefteLX1 = poses[0].pose.keypoints[11].position.x;
  huefteLY1 = poses[0].pose.keypoints[11].position.y;
  schulterLX1 = poses[0].pose.keypoints[5].position.x;
  schulterLY1 = poses[0].pose.keypoints[5].position.y;
  
  huefteLX2 = poses[1].pose.keypoints[11].position.x;
  huefteLY2 = poses[1].pose.keypoints[11].position.y;
  schulterLX2 = poses[1].pose.keypoints[5].position.x;
  schulterLY2 = poses[1].pose.keypoints[5].position.y;
  
  //Pixelanzahl zwischen Schulter und Huefte bestimmen (bei 2 m Abstand)
    //y2-y1 (Abstand vertikal)
  abstandHS1 = huefteLY1-schulterLY1;
  abstandHS2 = huefteLY2-schulterLY2;
  
  
  //mit dem antiproportinalen Dreisatz und neuer Pixelanzahlen die jeweilige Entfernung berechnen
  abstandK1 = 200*127/abstandHS1;
  abstandK2 = 200*127/abstandHS2;
  
  //Berechnen des Abstands zwischen den Personen mit Hilfe des Kosinussatzes
  abstandFinal = sqrt(pow(abstandK1,2)+pow(abstandK2,2)-2*abstandK1*abstandK2*cos(60));
  
  //Ausgabe des Abstands zwischen den zwei Personen
  console.log ('Der Abstand zwischen den zwei Personen: '+abstandFinal);
  
  //eventuell müssen 50 cm raufgerechnet werden, da das die ungefähre Abweichung des berechneten Werts von der Realität ist
  abstandFinal = abstandFinal+50;
  }

  var distance = abstandFinal; // der Wert, den man an den Server schickt
    var xhttp = new XMLHttpRequest();
    xhttp.open("POST", '/dist', true); 
    //Den richtigen POST-Request-Header schicken:
    xhttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
 
    xhttp.onreadystatechange = function() { // Diese Funktion wird aufgerufen, sobald der Zustand sich aendert
        if (this.readyState === XMLHttpRequest.DONE && this.status === 200) {
            // Request ausgefuehrt. Weitere Aktionen koennen ausgefuehrt werden.
        }
    }
    xhttp.send("distance=" + distance); // den Wert als Eigenschaft distance schicken

}

function modelReady(){
  console.log('model ready');
}

function draw() {
  image(video,0,0);
  fill (255,0,0);
}

